## mingw-w64-vsgpoints-0.6.0-1.src.tar.zst

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12)

project(vsgPoints
    VERSION 0.6.0
    DESCRIPTION "VulkanSceneGraph Point Cloud rendering."
    LANGUAGES CXX
)
set(VSGPOINTS_SOVERSION 0)
SET(VSGPOINTS_RELEASE_CANDIDATE 0)

set(VSGPOINTS_SOURCE_DIR "${CMAKE_CURRENT_SOURCE_DIR}" CACHE INTERNAL "Root source directory of vsgPoints")
set(VSGPOINTS_BINARY_DIR "${CMAKE_CURRENT_BINARY_DIR}" CACHE INTERNAL "Root binary directory of vsgPoints")

# set the use of C++17 globally as all examples require it
set(CMAKE_CXX_STANDARD 17)

# Find Vulkan and the VSG
if (VULKAN_SDK)
    set(ENV{VULKAN_SDK} ${VULKAN_SDK})
endif()

find_package(vsg 1.1.4 REQUIRED)
find_package(vsgXchange 1.0.5 REQUIRED)

vsg_setup_build_vars()
vsg_setup_dir_vars()

vsg_add_target_clang_format(
    FILES
        include/vsgPoints/*.h
        src/vsgPoints/*.cpp
)
vsg_add_target_clobber()
vsg_add_target_cppcheck(
    FILES
        ${CMAKE_SOURCE_DIR}/src/vsgPoints/*.cpp
        ${CMAKE_SOURCE_DIR}/include/vsgPoints/*.h
    )
vsg_add_target_docs(
    FILES
        include
)
vsg_add_target_uninstall()

if (${CMAKE_CURRENT_SOURCE_DIR} STREQUAL ${CMAKE_SOURCE_DIR})

    vsg_add_option_maintainer(
        PREFIX v
        RCLEVEL ${VSGPOINTS_RELEASE_CANDIDATE}
    )

endif()

# source directories for vsgPoints library
add_subdirectory(src)
add_subdirectory(applications)

vsg_add_feature_summary()

=== applications/CMakeLists.txt ===
add_subdirectory(vsgpoints_example)

=== src/CMakeLists.txt ===
add_subdirectory(vsgPoints)

=== applications/vsgpoints_example/CMakeLists.txt ===
set(SOURCES
    ConvertMeshToPoints.cpp
    vsgpoints_example.cpp
)

add_executable(vsgpoints_example ${SOURCES})

target_link_libraries(vsgpoints_example vsg::vsg vsgPoints::vsgPoints)

if (vsgXchange_FOUND)
    target_compile_definitions(vsgpoints_example PRIVATE vsgXchange_FOUND)
    target_link_libraries(vsgpoints_example vsgXchange::vsgXchange)
endif()

install(TARGETS vsgpoints_example RUNTIME DESTINATION bin)

=== src/vsgPoints/CMakeLists.txt ===

# vars used to enable subdirectories to extend the build of the vsgPoints library in a loosely coupled way
set(EXTRA_DEFINES)
set(EXTRA_INCLUDES)

SET(HEADER_PATH ${VSGPOINTS_SOURCE_DIR}/include/vsgPoints)

set(HEADERS
    ${HEADER_PATH}/Export.h
    ${HEADER_PATH}/AsciiPoints.h
    ${HEADER_PATH}/BIN.h
    ${HEADER_PATH}/Brick.h
    ${HEADER_PATH}/Bricks.h
    ${HEADER_PATH}/BrickShaderSet.h
    ${HEADER_PATH}/Settings.h
    ${HEADER_PATH}/create.h
 )

set(SOURCES
    AsciiPoints.cpp
    BIN.cpp
    Brick.cpp
    Bricks.cpp
    BrickShaderSet.cpp
    create.cpp
)

add_library(vsgPoints ${HEADERS} ${SOURCES})

# add definitions to enable building vsgPoints as part of submodule
add_library(vsgPoints::vsgPoints ALIAS vsgPoints)
set(vsgPoints_FOUND TRUE CACHE INTERNAL "vsgPoints found.")
set(CMAKE_DISABLE_FIND_PACKAGE_vsgPoints TRUE CACHE INTERNAL "Disable find_package(vsgPoints) as it's not necessary.")

set_property(TARGET vsgPoints PROPERTY VERSION ${VSGPOINTS_VERSION_MAJOR}.${VSGPOINTS_VERSION_MINOR}.${VSGPOINTS_VERSION_PATCH})
set_property(TARGET vsgPoints PROPERTY SOVERSION ${VSGPOINTS_SOVERSION})
set_property(TARGET vsgPoints PROPERTY POSITION_INDEPENDENT_CODE ON)
set_property(TARGET vsgPoints PROPERTY CXX_STANDARD 17)

target_compile_definitions(vsgPoints PRIVATE ${EXTRA_DEFINES})

target_include_directories(vsgPoints PUBLIC
    $<BUILD_INTERFACE:${VSGPOINTS_SOURCE_DIR}/include>
    $<BUILD_INTERFACE:${VSGPOINTS_SOURCE_DIR}/include/vsgPoints>
    $<INSTALL_INTERFACE:include>
    ${EXTRA_INCLUDES}
)

target_link_libraries(vsgPoints
    PUBLIC
        vsg::vsg
    PRIVATE
        ${EXTRA_LIBRARIES}
)

install(TARGETS vsgPoints ${INSTALL_TARGETS_DEFAULT_FLAGS})

if (BUILD_SHARED_LIBS)
    target_compile_definitions(vsgPoints INTERFACE VSGPOINTS_SHARED_LIBRARY)
endif()


install(DIRECTORY ${VSGPOINTS_SOURCE_DIR}/include/vsgPoints DESTINATION include)

vsg_add_cmake_support_files(
    CONFIG_TEMPLATE
        vsgPointsConfig.cmake.in
)

=== PKGBUILD ===
# Maintainer: Konstantin Podsvirov <konstantin@podsvirov.pro>

_realname=vsgPoints
pkgbase=mingw-w64-${_realname,,}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname,,}"
         "${MINGW_PACKAGE_PREFIX}-${_realname,,}-docs")
pkgver=0.6.0
pkgrel=1
pkgdesc="VulkanSceneGraph library and example suite for rendering point clouds (mingw-w64)"
arch=('any')
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
url='http://www.vulkanscenegraph.org/'
msys2_repository_url='https://github.com/vsg-dev/vsgPoints'
license=('spdx:MIT')
depends=("${MINGW_PACKAGE_PREFIX}-vulkanscenegraph")
makedepends=("${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-vsgxchange"
             "${MINGW_PACKAGE_PREFIX}-vulkan-headers"
             "${MINGW_PACKAGE_PREFIX}-doxygen"
             "${MINGW_PACKAGE_PREFIX}-graphviz")
optdepends=("${MINGW_PACKAGE_PREFIX}-vsgxchange: Used by examples")
source=("${msys2_repository_url}/archive/v${pkgver}/${_realname}-${pkgver}.tar.gz")
sha256sums=('f907d76231bb929b02846d12143fb60f815bb6a7a9c6a98e48cad1c8b184de75')

build() {
  declare -a extra_config
  if check_option "debug" "n"; then
    extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
    "${MINGW_PREFIX}"/bin/cmake.exe \
      -GNinja \
      -DCMAKE_INSTALL_PREFIX="${MINGW_PREFIX}" \
      "${extra_config[@]}" \
      -DBUILD_{SHARED,STATIC}_LIBS=ON \
      -S "${_realname}-${pkgver}" \
      -B "build-${MSYSTEM}"

  "${MINGW_PREFIX}"/bin/cmake.exe --build "build-${MSYSTEM}"

  "${MINGW_PREFIX}"/bin/cmake.exe --build "build-${MSYSTEM}" --target docs
}

package_vsgpoints() {
  DESTDIR="${pkgdir}" "${MINGW_PREFIX}"/bin/cmake.exe --install "build-${MSYSTEM}"

  install -Dm644 "${srcdir}/${_realname}-${pkgver}/LICENSE.md" "${pkgdir}${MINGW_PREFIX}/share/licenses/${_realname,,}/LICENSE.md"
}

package_vsgpoints-docs() {
  pkgdesc+=" (documentation)"
  depends=()

  mkdir -p "${pkgdir}${MINGW_PREFIX}/share/doc/${_realname,,}"
  cp -r "build-${MSYSTEM}/html" "${pkgdir}${MINGW_PREFIX}/share/doc/${_realname,,}/"
}

# template start; name=mingw-w64-splitpkg-wrappers; version=1.0;
# vim: set ft=bash :

# generate wrappers
for _name in "${pkgname[@]}"; do
  _short="package_${_name#${MINGW_PACKAGE_PREFIX}-}"
  _func="$(declare -f "${_short}")"
  eval "${_func/#${_short}/package_${_name}}"
done
# template end;
